/*!
  * file Wilson.ino
  * version  V1.0
  * date  2021-6-15
  */

#include <Arduino.h>
#include <HardwareSerial.h>
#include <SoftwareSerial.h>
#include "DFRobot_SerialScreen771.h"


SoftwareSerial EEBlue(3,2); // RX | TX
SoftwareSerial Serial1(7, 6); //RX, TX
DFRobot_SerialScreen771 screen;
const char* str = "*";
eMoveMode_t buf[]= {eMove_left,eMove_right,eMove_hold,eMove_down,eMove_up,eMove_flash};
int iBuffIndex = 0;
int iMaxBuffIndex = 5;

void setup() {
    /*Initialize communication interface (Serial1) and debug interface (Serial)*/
    Serial.begin(9600);
    Serial1.begin(19200);
    EEBlue.begin(9600);  //Default Baud for comm, it may be different for your Module. 
    screen.begin(Serial1);
    screen.setDbgSerial(Serial);
    delay(4);
    /*Display string "DFRobot"*/
    screen.setMessage(str);
    /*Set the move mode to hold*/
    /*eMoveMode_t: eMove_left = left
                   eMove_right = right
                   eMove_hold = hold
                   eMove_down = down
                   eMove_up = up
                   eMove_flash = flash
    */
    screen.setMoveMode(eMove_hold);
    screen.setMoveSpeed(eSpeedLevel_8);
    Serial.println("The bluetooth gates are open.\n Connect to HC-05 from any other bluetooth device with 1234 as pairing key!.");

}

void processCommand(String command) {
    if (iBuffIndex<iMaxBuffIndex) { iBuffIndex++;} else { iBuffIndex=0;}
    Serial.println("Command Received:\t"+command+" iBuffIndex="+iBuffIndex);
    
    screen.setMessage(command.c_str());
    screen.setMoveMode(buf[iBuffIndex]);
}

void loop() {
    /*Switch a mobile display mode every 5s*/
    if (EEBlue.available())
    {
        processCommand(EEBlue.readString());
    }
}
